﻿(function () {
    var ns = namespace("Hud");

    //ns.update = function update(time) {
    //}

    ns.render = function render(batch, time) {
        var text = "(R)eset";
        var size = 25;

        if (!this.content) {
            this.content = this.Game.Content;

            this.font = this.Game.Font;
            var s = this.font.Measure(text, size, 1.0, true);
            this.textSize = { x: s.X, y: s.Y };

            this.graphicsDevice = this.Game.GraphicsDevice;

            this.diagram = this.content.LoadTexture("diagram.png");
            this.white = new HdrColors(new HdrColor(255, 255, 255));

            this.keyTextures = [
                new SubTexture(this.content.LoadTexture("key_hud.png"), new RectangleF(0, 0, 56, 56)),
                new SubTexture(this.content.LoadTexture("key_hud.png"), new RectangleF(56, 0, 56, 56)),
            ];

            this.textColors = [
                new HdrColor(224, 224, 128), new HdrColor(160, 224, 224),
                new HdrColor(32, 32, 96), new HdrColor(32, 32, 96)
            ];
        }

        var screenWidth = this.graphicsDevice.BackbufferWidth;
        var screenHeight = this.graphicsDevice.BackbufferHeight;

        this.textPos = {
            x: (screenWidth - this.textSize.x) / 2,
            y: screenHeight - this.textSize.y
        };

        this.font.Draw(text, size,
            new Vector2(this.textPos.x, this.textPos.y),
            this.textColors[0], this.textColors[1],
            true, this.textColors[2], this.textColors[3]);

        if (typeof this.FloorNumber === "number" && typeof this.MapNumber === "number") {
            if (!this.worldTextSize) {
                var s = this.font.Measure("Stage " + this.FloorNumber + "-" + this.MapNumber, size, 1.0, true);
                this.worldTextSize = { x: s.X, y: s.Y };
            }
            this.font.Draw("Stage " + this.FloorNumber + "-" + this.MapNumber, size,
                new Vector2((screenWidth - this.worldTextSize.x) / 2, this.textPos.y - this.worldTextSize.y * 1.1),
                this.textColors[0], this.textColors[1],
                true, this.textColors[2], this.textColors[3]);
        }

        if (this.pressAnyKey) {
            var text = "Congratulations! Press any key to continue.";
            if (!this.continueTextSize) {
                var s = this.font.Measure(text, size, 1.0, true);
                this.continueTextSize = { x: s.X, y: s.Y };
            }
            this.font.Draw(text, size,
                new Vector2((screenWidth - this.continueTextSize.x) / 2, (screenHeight - this.continueTextSize.y) / 2 - 32),
                this.textColors[0], this.textColors[1],
                true, this.textColors[2], this.textColors[3]);
        }
            
        batch.Begin();
        batch.Draw(this.diagram, new Vector2(24, 24), this.white);
        batch.Draw(this.keyTextures[this.hasKey ? 1 : 0], new Vector2(screenWidth - 24 - 56, 24), this.white);
        batch.End();
    }

    return ns;
}());